/*  Shift-Or algoritmus provadi hledani vzorku v textu  */
/*                                                      */
/* Vypracoval: Lukas Trombik                            */
/* Datum:      29.12.2001                               */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/* Predbezne zpracovani */
int preSo(char *x, int m, unsigned int *S) {
  unsigned int j, lim;
  int i;
  for (i = 0; i < m; ++i)
    S[i] = ~0;
  for (lim = i = 0, j = 1; i < m; ++i, j <<= 1) {
    S[x[i]] &= ~j;
    lim |= j;
  }
  lim = ~(lim>>1);
  return(lim);
}

void SO(char *x, int m, char *y, int n) {
  unsigned int lim, state;
  unsigned int *S;
  int j;

  S=(unsigned int *)malloc(m*sizeof(unsigned int));
  /*volani Predbezneho zpracovani */
  lim = preSo(x, m, S);
  /* Vyhledani pomoci algoritmu Shift-Or*/
  for (state = ~0, j = 0; j < n; ++j) {
    state = (state<<1) | S[y[j]];
    if (state < lim)
      printf("%d; ",j-m+1);
  }
 free(S);
}

/* Volani funkce Shift-Or algoritmu*/
int main(int argc, char *argv[]) {
  FILE *f;
  char radka[80];
  int tt,tv;


 if (argc<3) {
   printf("\n Pouziti: Shift_or vzor zdroj\n");
   return 1;
 }

 if ((f=fopen(argv[2],"rt")) == NULL) {
   fprintf(stderr, "Nemohu otevrit soubor.\n");
   return 1;
 }

 tv=strlen(argv[1]);
 while (fgets(radka,80,f)!=NULL) {
   tt=strlen(radka);
   SO(argv[1],tv,radka,tt);
 }
  printf("\n");
  fclose(f);
  return 0;
}
/*Konec programu*/
